﻿Type=Class
Version=2.00
@EndOfDesignText@
'Class module
Private Sub Class_Globals
Type NodeC(pnl As Panel, _
		   btn As Button, _
		   lbl As Label, _
		   IMG As ImageView, _
		   tag As String, _
		   level As Int, _
		   parent As Node, _
		   children As List)
Dim TN As NodeC
Private plus,minus As Bitmap
Private lh,lw As Int
Private Cmodule As Tree	
End Sub

'Initializes the object. 
'Module is the calling module
'parent is the parent Node
'level is one more then the parent's level
'linewidth is the width of the node's panel
'lineheight Is the height of the Node's panel
'Text is the node's label text
'img is the bitmap of the node
'tag and tag1 are tags for use with the control of the tree.
Sub Initialize(Module As Tree, _
			   parent As Node, _
			   level As Int, _
			   linewidth As Int, _
			   lineheight As Int, _
			   Text As String, _
			   TextSize As Int, _
			   TextColor As Int, _
			   LabelColor As Int, _
			   img As Bitmap, _
			   tag As String, _
			   tag1 As String	 )

lh = lineheight
lw = linewidth 
plus.Initialize(File.DirAssets,"plus2.png")
minus.Initialize(File.DirAssets,"minus2.png")
Cmodule = Module

TN.Initialize
TN.pnl.Initialize("lbl")
TN.img.Initialize("lbl") ' will do the same action as the label.
TN.img.Gravity = Gravity.FILL
TN.btn.Initialize("btn")
If img <> Null Then TN.img.SetBackgroundImage(img) 
If tag1 = "plus" Then 
	TN.btn.SetBackgroundImage(plus)
Else 
	TN.btn.Visible = False
End If
TN.btn.tag = tag1
TN.lbl.Initialize("lbl")
TN.children.Initialize
If parent <> Null Then 
	TN.parent = parent
	TN.parent.TN.children.Add(Me)
End If
TN.lbl.Text = Text
TN.lbl.TextSize = TextSize
TN.lbl.TextColor = TextColor
TN.lbl.color = LabelColor

TN.tag = tag 
TN.level = 0 

TN.pnl.AddView(TN.btn, 0.05*lh, 0.05*lh, 0.9*lh,    0.9*lh)
TN.pnl.AddView(TN.img, lh* 1.2, 0.05*lh, 0.9*lh,    0.9*lh)
TN.pnl.AddView(TN.lbl, 2.5*lh,  0.05*lh, lw-2.5*lh, 0.9*lh)
TN.level = level

'----------------------------------------
	Dim r As Reflector
	r.Target = TN.pnl
	r.SetOnTouchListener("touched")
	r.Target = TN.lbl
	r.SetOnTouchListener("touched")
	r.Target = TN.btn
	r.SetOnTouchListener("touched")
	r.Target = TN.img
	r.SetOnTouchListener("touched")
'----------------------------------------
End Sub

Sub getTag
Return TN.tag
End Sub

Sub AsView As View
Return TN.pnl
End Sub

Sub setTextSize(size As Int)
TN.lbl.TextSize = size
End Sub

Sub btn_click
If TN.btn.tag = "plus" Then
	TN.btn.SetBackgroundImage(minus)
	TN.btn.tag = "minus"
	Cmodule.Node_Open(Me)	
Else If TN.btn.tag = "minus" Then
	TN.btn.SetBackgroundImage(plus)
	TN.btn.tag = "plus"
	Cmodule.Node_close(Me)	
Else
	' do nothing
End If
End Sub

'----------------------------------------
Sub lbl_click
	If Cmodule.DontClickMe Then Return
	Cmodule.Node_Click(Me)
End Sub

Sub lbl_longclick
	If Cmodule.DontClickMe Then Return
	Cmodule.Node_longClick(Me)
End Sub

Sub touched(ViewTag As Object, Action As Int, X As Float, Y As Float, MotionEvent As Object) As Boolean
	Cmodule.HorizontalScroll( Action, X, Y )
End Sub
'----------------------------------------
