﻿Type=Class
Version=2.00
@EndOfDesignText@
'Class module
Private Sub Class_Globals
Private fileimg, folder As Bitmap
Private x0,y0, Lmin, Lmax As Float
Private lw, lh, delta, TSize, TColor, TLcolor, SP_Height, SP_Color, w As Int
Private datalist, btntaglist As List
Private rootnode, nd() As Node	
Private myparent As Object
Private TRP, SlidePanel As Panel
Private treeview As ScrollView
Private TText, TRoot As String

'----------------------------------------
Public DontClickMe As Boolean
Private MoveInProgress As Boolean
Private pxTouchSlop As Int
Private tim As Timer
'----------------------------------------
End Sub

'Initializes the object.
'Parent is the Parent object - activity or panel 
'Color - the color of the scrollview panel
'Defaults: for line width - 350dip, line height - 40dip
'fontsize - 20, fontcolor white, label color black.
'To change the default use setAppearance or specific methods.
Public Sub Initialize(Parent As Object,Color As Int)
myparent = Parent
treeview.Initialize2(100%y,"treeview")
treeview.Panel.Initialize("")
treeview.Panel.Color = Color

TRP.Initialize("")  ' TRP is the base panel , holds both the scrollview and the slidepanel.
TRP.AddView(treeview,0,0,-1,-1)

lw = 350dip
lh = 40dip
TSize = 20
TColor = Colors.White
TLcolor = Colors.Black

SP_Height = 36dip
SP_Color = Colors.LightGray

folder.Initialize(File.DirAssets,"folder2.png")
fileimg.Initialize(File.DirAssets,"file.png")

'----------------------------------------
Dim r As Reflector
r.Target = r.RunStaticMethod("android.view.ViewConfiguration", "get", Array As Object(r.GetContext), Array As String("android.content.Context"))
pxTouchSlop = r.RunMethod("getScaledTouchSlop")
tim.Initialize("WaitAfterTouch", r.RunMethod("getTapTimeout"))
r.Target = treeview
r.SetOnTouchListener("treeview_touch")
'----------------------------------------

End Sub

'Linewidth and Lineheight refer to the node's panel size.
'Size is fontsize.
Sub setAppearance(LineWidth As Int, LineHeight As Int, Size As Int, Textcolor As Int, lblcolor As Int)
lw = LineWidth
lh = LineHeight
TSize = Size
TColor = Textcolor
TLcolor = lblcolor
End Sub

'Root is the root of the tree (i.e. File.DirRootExternal for file tree)
'Text is the name of the Root as will appear in the display.
Sub setRoot(Root As String,Text As String)
TText = Text
TRoot = Root
rootnode.Initialize(Me,Null,0,lw,lh,TText, TSize, TColor,  TLcolor, folder,TRoot,"plus" )
treeview.Panel.AddView(rootnode.AsView,0,0,lw,lh)
End Sub

'Sets the hieght and color parameters of the SlidePanel at the bottom.
Sub setSlidePanel(SlidePanelHeight As Int, SlidePanelColor As Int)
SP_Height = SlidePanelHeight
SP_Color = SlidePanelColor
If SlidePanel.IsInitialized Then
	SlidePanel.Color = SP_Color
	SlidePanel.Height = SP_Height
	SlidePanel.Top = TRP.Height-SP_Height
End If
End Sub

'Returns the object reference
Sub AsView As View
Return  TRP
End Sub

Sub setLineWidth(Value As Int)
lw = Value
End Sub

Sub setLineHeight(Value As Int)
lh = Value
End Sub

Sub setTextSize(Size As Int)
TSize = Size
End Sub

Sub setTextColor(Color As Int)
TColor = Color
End Sub

Sub setLabelColor(Color As Int)
TLcolor = Color
End Sub

'Gets the list of items for new nodes. Returns -1 if the list is empty.
Sub get_data(dir As String) As Int 
' this part is now for files management, can be adapted to other kinds of data to be shown as tree
datalist =  File.ListFiles(dir)
If datalist.IsInitialized = False Then Return -1
btntaglist.Initialize   
For i = 0 To datalist.Size - 1
	If File.IsDirectory(dir, datalist.Get(i)) Then 
		btntaglist.Add("plus") 
	Else 
		btntaglist.Add("")
	End If
Next
Return 1
End Sub

'Closes an open node
Sub Node_Close(tnode As Node)
delta = 0   ' a counter for collapsed lines       
remove_children(tnode)
move_nodes( tnode.AsView.Top ,-delta) ' move lower nodes up
End Sub

'Expands a node and creates new nodes as children nodes.
Sub Node_Open(tnode As Node)
Dim tbmp As Bitmap
If get_data(tnode.getTag) = -1 Then Return
Dim nd(datalist.Size) As Node

move_nodes( tnode.TN.pnl.Top ,datalist.Size)

For i = 0 To datalist.Size-1         ' assign data items to new nodes
	If btntaglist.Get(i) = "plus" Then 
		tbmp = folder
	Else 
		tbmp = fileimg
	End If
	nd(i).Initialize(Me,tnode,tnode.TN.level + 1,lw,lh,datalist.Get(i),TSize,TColor,TLcolor,tbmp, tnode.getTag & "/" & datalist.Get(i), btntaglist.Get(i) )
	treeview.Panel.AddView(nd(i).AsView, nd(i).TN.level*lh,tnode.AsView.Top +(i+1)*lh,lw,lh)
	nd(i).setTextSize(TSize)
Next

If tnode.TN.level = 0 Then   ' do this only once but only after the tree has been added to his parent.
	If myparent Is Panel Then 
		Dim p As Panel
		p = myparent
		w = p.Width
	Else
		w = Min(100%x, TRP.Width)  'it's an activity
	End If
	Lmin = TRP.Left
	Lmax = w
End If

If SlidePanel.IsInitialized = False AND (tnode.TN.level+1) * lh + lw > w Then
	SlidePanel.Initialize("SlidePanel")
	SlidePanel.Color = SP_Color
	TRP.AddView(SlidePanel,0,TRP.Height-SP_Height,-1,SP_Height)
	SlidePanel.BringToFront
End If
End Sub

Private Sub move_nodes( top As Int,lines As Int)
Dim v As View
For j = 0 To treeview.Panel.NumberOfViews - 1  
	v = treeview.Panel.GetView(j)
	If v.top  > top Then
		v.top = v.top + lines * lh
	End If
Next
treeview.Panel.Height = treeview.Panel.Height + lines * lh
End Sub

Private Sub remove_children(Rnode As Node)  ' close a node
Dim delnode As Node

For i =  Rnode.TN.children.Size - 1 To 0 Step - 1
	delta = delta + 1
 	delnode = Rnode.TN.children.Get(i)
								 ' recursion if the sub node is open
	If delnode.TN.btn.tag = "minus" Then remove_children(delnode) 
	delnode.TN.pnl.RemoveView  ' then delete it
Next
Rnode.TN.children.Clear  ' zero the child list in the closing node
End Sub

'Reacts to Node Click event
Sub Node_Click(tnode As Node)
'in this sub do what you want with this selected item, for example - color the panel and label
tnode.TN.pnl.Color = Colors.blue
tnode.TN.lbl.Color = Colors.blue
End Sub

'Reacts to Node LongClick event
Sub Node_LongClick(tnode As Node)
'in this sub do what you want with this selected item, for example - color the panel and label
tnode.TN.pnl.Color = Colors.black
tnode.TN.lbl.Color = Colors.black
End Sub

'----------------------------------------
Private Sub treeview_touch(ViewTag As Object, Action As Int, X As Float, Y As Float, MotionEvent As Object) As Boolean
	HorizontalScroll( Action, X , Y )
End Sub

Private Sub WaitAfterTouch_Tick
	' We waited enough time -> the touch can be interpreted as a click
	DontClickMe = False
	tim.Enabled = False
End Sub

Public Sub HorizontalScroll(Action As Int, x As Float, Y As Float)
	Select Case Action
		Case 0
			' Remember where we start
			x0 = x

			' Start timer and reset DontClickMe
			tim.Enabled = True
			DontClickMe = True

			' Reset the move flag
			MoveInProgress = False
		Case 1
	 		' Stop timer
			tim.Enabled = False
			Return
		Case 2
				' Do we move enough to scroll (or the finger is just wandering) ?
				Dim xDiff As Int
				xDiff = Abs(x - x0)
				If Not(MoveInProgress) Then
		  			If xDiff < pxTouchSlop Then
						Return
					Else
						MoveInProgress = True
					End If
				End If

				' It's a big move -> that can't be a click (we stop the timer because it's useless now)
				tim.Enabled = False
				DontClickMe = True

				' We discard too big moves (we don't handle velocity and flings)
		  		If xDiff > pxTouchSlop * 3 Then
					x0 = x
					Return
				End If
				Dim NewLeft As Int
				NewLeft =  TRP.Left + x - x0
				If NewLeft > Lmin Then 
					TRP.Left = Lmin
				Else If NewLeft < Lmax - TRP.Width  Then 
					TRP.Left = Lmax - TRP.Width
				Else
					TRP.Left = NewLeft
				End If
    End Select
End Sub
'----------------------------------------

'Remove all nodes from the tree, including the root.
Sub ClearTree
rootnode.TN.btn.Tag = "minus"
rootnode.btn_click
rootnode.TN.pnl.RemoveView
If SlidePanel.IsInitialized Then SlidePanel.RemoveView
End Sub
